<template>
  <v-app class="purposeOfTreatment">
    <div class="purposeOfTreatment__title">
      <h1>Назначение лечения</h1>
    </div>

    <!--Поиск лекарств-->
    <v-text-field class="purposeOfTreatment__search" v-model="search" append-icon="mdi-magnify" label="Поиск.."
                  single-line hide-details></v-text-field>

    <v-data-table
        :headers="headers"
        :items="purposesOfTreatments"
        :search="search"
        class="purposeOfTreatment__table"
    >

      <template #item.full_name="{ item }">{{ item.user.surname }} {{ item.user.name }} {{
          item.user.fatherName
        }}
      </template>

      <template #item.patientFullName="{ item }">{{ item.patientResponse.surname }} {{ item.patientResponse.name }}
        {{ item.patientResponse.fatherName }}
      </template>

      <template v-slot:item.actionsService="{ item }">
        <v-card-text class="mr-2 routerOnPage" @click="routerOnPageService(item)">Подробнее</v-card-text>
      </template>

      <template v-slot:item.actionsDrug="{ item }">
        <v-card-text class="mr-2 routerOnPage" @click="routerOnPageDrug(item)">Подробнее</v-card-text>
      </template>


      <template v-slot:top>
        <v-toolbar flat>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" max-width="500px">
            <template v-slot:activator="{ on, attrs }">
              <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on" @click="loadPage">Назначить лечение
              </v-btn>
            </template>

            <!--Добавление лекарства-->
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="6">
                      <v-text-field v-model="editedItem.dateStart" label="Начало лечения"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-overflow-btn v-model="editedItem.medicalCardId" :items="medicalCards" item-value="id"
                                      :item-text="item => item.name +' ' +item.surname+' '+item.fatherName"
                                      label="Медкарта"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-overflow-btn v-model="editedItem.serviceId" :items="services" item-value="id" item-text="name"
                                      label="Услуга"/>
                      <v-col cols="12" sm="6" md="6">
                        <v-icon small class="mr-2" @click="addService()"> mdi-plus</v-icon>
                        <span class="text ml-7">{{ servicesToSave.length }}</span>
                      </v-col>

                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-text-field v-model="editedItem.serviceCount" label="Количество услуг" :rules="countRules"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-overflow-btn v-model="editedItem.drugId" :items="drugs" item-value="id" item-text="name"
                                      label="Лекарство"/>
                      <v-col cols="12" sm="6" md="6">
                        <v-icon small class="mr-2" @click="addDrug()"> mdi-plus</v-icon>
                        <span class="text ml-7">{{ drugsToSave.length }}</span>
                      </v-col>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-text-field v-model="editedItem.drugCount" label="Количество лекарств" :rules="countRules"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-overflow-btn v-model="editedItem.doctorName" :items="doctors" item-value="id"
                                      :item-text="item => item.name +' ' +item.surname+' '+item.fatherName"
                                      label="Врач"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-overflow-btn v-model="editedItem.medicalStaffName" :items="medicalStaffs" item-value="id"
                                      :item-text="item => item.fullName +' - ' +item.role" label="Медперсонал"/>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="close">Закрыть</v-btn>
                <v-btn color="blue darken-1" text @click="save">Сохранить</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
    </v-data-table>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "PurposeOfTreatment",
  data() {
    return {
      search: '',
      dialog: false,
      dialogDelete: false,
      editedIndex: -1,
      editedId: -1,

      purposesOfTreatments: [],
      medicalCards: [],
      medicalCardsDisease: [],
      services: [],
      servicesNames: [],
      serviceMedication: [],
      drugMedication: [],
      drugs: [],
      drugsNames: [],
      doctors: [],
      doctorsNames: [],
      medicalStaffs: [],
      medicalStaffsNames: [],
      servicesToSave: [],
      drugsToSave: [],

      countRules: [
        v => !!v || 'Заполните это поле',
        v => /^[0-9]+$/.test(v) || 'Поле должно содержать положительные цифры'
      ],

      editedItem: {
        dateStart: 'YYYY-MM-DD',
        medicalCardId: '',
        serviceId: '',
        serviceCount: '0',
        drugId: '',
        drugCount: '0',
        doctorName: '',
        medicalStaffName: ''
      },

      headers: [
        {
          text: 'Дата начала лечения',
          value: 'dateStart',
          sortable: false
        },
        {
          text: 'Врач',
          value: 'full_name',
          sortable: false
        },
        {
          text: 'Медперсонал',
          value: 'medicalStaff.fullName',
          sortable: false
        },
        {
          text: 'Пациент',
          value: 'patientFullName',
          sortable: false
        },
        {
          text: 'Услуга',
          value: 'actionsService',
          sortable: false
        },
        {
          text: 'Лекарство',
          value: 'actionsDrug',
          sortable: false
        },
      ]
    }
  },

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? 'Новая запись' : 'Редактировать запись'
    },
  },

  watch: {
    dialog(val) {
      val || this.close()
    },
    dialogDelete(val) {
      val || this.closeDelete()
    },
  },

  mounted() {
    this.fetchPurposeOfTreatment()
  },

  methods: {
    async fetchPurposeOfTreatment() {
      axios
          .get(this.$root.globalVar + '/medication')
          .then(response => {
            this.purposesOfTreatments = response.data
            console.log(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.medicalCardsDisease = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/drug')
          .then(response => {
            this.drugsNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/service')
          .then(response => {
            this.servicesNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/medical_staff')
          .then(response => {
            this.medicalStaffsNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async addDiseaseRecommendation(item) {
      axios.post(this.$root.globalVar + '/medication', {
        medicalCardId: item.medicalCardId,
        medicationRequest:
            {
              dateStart: item.dateStart,
              userId: item.doctorName,
              medicalStaffId: item.medicalStaffName,
            },
        services: this.servicesToSave,
        drugs: [
          {
            count: item.drugCount,
            drugId: item.drugId
          }
        ]
      })
          .then(response => {
            console.log(this.purposesOfTreatments)
            this.purposesOfTreatments.push(response.data)
            console.log(this.purposesOfTreatments)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    async fetchServiceMedication(id) {
      axios
          .get(this.$root.globalVar + '/medication_service/patient/' + id)
          .then(response => {
            this.serviceMedication = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchDrugMedication(id) {
      axios
          .get(this.$root.globalVar + '/receipt/patient/' + id)
          .then(response => {
            this.drugMedication = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    routerOnPageService(item) {
      console.log(item)
      this.fetchServiceMedication(item.patientResponse.id)
      this.$router.push('/patient_service_medication/' + (item.patientResponse.id))
    },

    routerOnPageDrug(item) {
      this.fetchDrugMedication(item.patientResponse.id)
      this.$router.push('/patient_drug_medication/' + (item.patientResponse.id))
    },

    addService() {
      const service = {
        serviceId: this.editedItem.serviceId,
        count: this.editedItem.serviceCount
      }

      this.servicesToSave.push(service)

      this.editedItem.serviceId = ''
      this.editedItem.serviceCount = '0'
    },

    addDrug() {
      const drug = {
        drugId: this.editedItem.drugId,
        count: this.editedItem.drugCount
      }

      this.drugsToSave.push(drug)

      this.editedItem.drugId = ''
      this.editedItem.drugCount = '0'
    },

    loadPage() {
      this.medicalCardsDisease.forEach(doctor => this.doctors.push(doctor.medication.user))
      this.medicalCardsDisease.forEach(patient => this.medicalCards.push(patient.patient))
      this.medicalStaffsNames.forEach(medicalStaff => this.medicalStaffs.push(medicalStaff))
      this.drugsNames.forEach(drug => this.drugs.push(drug))
      this.servicesNames.forEach(service => this.services.push(service))
      this.servicesToSave = []
      this.drugsToSave = []
    },

    close() {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
        this.editedId = -1
      })
    },

    save() {
      if (this.editedItem.dateStart === '' || this.editedItem.medicalCardId === '' || this.editedItem.serviceId === '' ||
          this.editedItem.serviceCount === '' || this.editedItem.drugId === '' || this.editedItem.drugCount === '' ||
          this.editedItem.doctorName === '' || this.editedItem.medicalStaffName === '') {
        alert('Ошибка! Подробности: введите данные.')
        throw new Error("Ошибка! Подробности: введите данные.");
      }

      else if (this.editedItem.drugCount <= 0 ||  this.editedItem.serviceCount <= 0) {
        alert('Ошибка! Подробности: введите верный формат данных')
        throw new Error("Ошибка! Подробности: введите верный формат данных.");
      }

      else {
        this.addDiseaseRecommendation(this.editedItem)
        this.close()
      }
    },
  }
}
</script>

<style lang="scss" scoped>
.purposeOfTreatment {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }

  &__table {
    width: 80%;
    margin: 0 auto;
  }
}

.v-text-field {
  flex: 0.2 0 !important;
  margin-top: 30px;
}

.routerOnPage {
  &:hover {
    cursor: pointer;
  }
}
</style>